#!/usr/bin/env python

# -*- coding: utf-8 -*-
"""
Created on Mon July 21 17:19:11 2014

Project Title : Image Resizer 

Project Version : 1.0

Powered By Python , PyQt4 and PIL

Copyright (c) 2013 - 2014 Amir Bakhtiary.

All Rights Reserved.

Coded In : 
    
    Python 2.7.6 
    
    Spyder : 2.2.5
    
    PIL : 1.1.7
    
    Python Qt : 4.8.6

Under : GNU General Public License, version 2

Full License Review Available On : http://www.gnu.org/licenses/gpl-2.0.html


Core Developer : Amir Bakhtiary 

Contact Details : 

    Yahoo : Encoder301@Yahoo.com 
    
    GMail : Infected.Operator@Gmail.com
    

"""


#Importing Modules .....
from __future__ import division
import sys
from imgreslib import starting,get_data,en,de,starting_multi
from imgreslib import about_msg
from imgreslib import getKB

try :#PyQt4 is not installed :|
    import PyQt4.QtGui as gui   
    from PyQt4.QtCore import Qt as qt
except ImportError,e1:
    #Handleing error
    print "Unable to import PyQt4"
    print e1
    print "Process terminated"
    print "Error\nConsole version not available on currenct version"
    
    sys.exit()
import os.path as osp   
import os 
from copy import copy
import webbrowser
import time
import shutil
#defining a function to save logs about application

def get_log(tp,inp,op=""):
    report="\r\non ["+str(time.ctime())+"]"+" "+inp+" "+tp+" and saved on "+op
    return report

argv2=copy(sys.argv)

app=gui.QApplication(sys.argv)

#Use QIcon class to define an icon in Qt


opt=[]
opt2=[]
opt3=[]

#get main path of application
home = osp.expanduser("~") 
os.chdir(home)
if ".image-resizer" not in os.listdir(home):
    os.mkdir(".image-resizer")
os.chdir(home+"/.image-resizer")
main_path=os.getcwd()
#Defining all icons of menubar and 
#application widgets


ico=gui.QIcon("ico.png")
exit_ico=gui.QIcon("icons/exit.png")
load_ico=gui.QIcon("icons/load.png")
start_ico=gui.QIcon("icons/start.png")
over_ico=gui.QIcon("icons/over.png")
qt_ico=gui.QIcon("icons/qt.png")
help_ico=gui.QIcon("icons/help.png")
view_ico=gui.QIcon("icons/view.png")
ico_i=gui.QIcon("icons/make.png")
del_ico=gui.QIcon("icons/del.png")    
pixmap = gui.QPixmap("icons/ban.png")



#Get name of the current user 

    
#detect folder of external files
    
    
if "core" in os.listdir(os.getcwd()):
    pass
else:
    os.mkdir("core")
try:
    f=open("core/log.txt")
    f.close()
except IOError:
    f=open("core/log.txt","w")
    f.close()
    
try:
    f=open("core/p_set.irf","r")
    try:
        os.chdir(de(f.read()))
    except:
        pass
    f.close()
except:
    f=open("core/p_set.irf","w")

    f.close()    
    
class Gui(gui.QMainWindow):
    
    """Base GUI class
    graphical user interface """
    
    def __init__(self):
        
        super(Gui,self).__init__()
        self.setWindowTitle("Image Resizer")
        self.setWindowIcon(ico)
        self.statusBar()
        #palette = gui.QPalette()
    
        #palette.setColor(gui.QPalette.Background,gui.QColor(45,62,80))
    
        #self.setPalette(palette)
        
        self.resize(390,450)
        
        self.setMinimumSize(self.size())
        
        
        #self.setMaximumSize(self.size())
        self.center()
        
        #Defineing Actions
        #actions in PyQt and Qt will use for menubar and toolbar        
        
        menubar=self.menuBar()
        
        act1=gui.QAction("Load Input",self)
        
        act1.setShortcut("Ctrl+O")
        
        act1.setIcon(load_ico)
        
        act1.setStatusTip("Load an input file")
        
        act1.triggered.connect(self.load_in)
        
        act2=gui.QAction("Load Output",self)
        #load image action
        

        act2.setShortcut("Ctrl+P")
        
        act2.setIcon(load_ico)
        
        act2.setStatusTip("Load an output file")
        
        act2.triggered.connect(self.load_out)       
        #load output image action
        
        
        act3=gui.QAction("Start",self)
        
        
        act3.setShortcut("Ctrl+S")
        
        act3.setIcon(start_ico)
        act3.setStatusTip("Start Working")
        act3.triggered.connect(self.start)
        
        act4=gui.QAction("Exit",self)
        
        act4.setShortcut("Ctrl+Q")
        act4.setIcon(exit_ico)
        act4.setStatusTip("Exit Application")
        
        act4.triggered.connect(sys.exit)
        
        act5=gui.QAction("About",self)
        
        act5.setIcon(ico)
        act5.setStatusTip("About Image Resizer")
        
        act5.triggered.connect(self.about)
        
        act6=gui.QAction("Overwrite",self)
        act6.setIcon(over_ico)
        act6.setStatusTip("Overwrite changes into the curent file")
        act6.triggered.connect(self.Over)

        act7=gui.QAction("About Qt",self)
        
        act7.setIcon(qt_ico)
        act7.setStatusTip("About Qt Cross Platform Library")
        
        act7.triggered.connect(self.about_Qt)
        
        act8=gui.QAction("Help",self)
        act8.setIcon(help_ico)
        act8.setStatusTip("See how to use application")
        
        act8.triggered.connect(self.open_m)
        
        act9=gui.QAction("View logs",self)
        act9.setStatusTip("View logs of the application")
        act9.setIcon(view_ico)
        act9.triggered.connect(self.viewlog)
        
        act10=gui.QAction("Delet logs",self)
        act10.setStatusTip("Delet logs of the application")
        act10.setIcon(del_ico)
        act9.setShortcut("Ctrl+M")
        act10.setShortcut("Ctrl+W")
        act10.triggered.connect(self.dellog)
        
        act11=gui.QAction("Copy logs",self)
        act11.setIcon(ico_i)
        act11.setShortcut("Ctrl+L")
        act11.setStatusTip("Copy logs of the application")
        act11.triggered.connect(self.copy_log)

        
        menu1=menubar.addMenu("File")

        
        menu3=menubar.addMenu("Tools")
        menu2=menubar.addMenu("Help")
        #adding action to our menus
        
        menu1.addAction(act1)
        
        menu1.addAction(act2)
        
        menu1.addSeparator()
        menu1.addAction(act3)
        
        menu1.addAction(act6)
        menu1.addSeparator()
        
        menu1.addAction(act4)
        
        menu2.addAction(act5)
        
        menu2.addAction(act7)
        
        menu2.addAction(act8)
        
        menu3.addAction(act9)
        menu3.addAction(act10)
        menu3.addAction(act11)
        
        #Define Status Bar
        
        self.status=gui.QStatusBar(self)
        
        self.status.setToolTip("Status Bar")
        
        
        self.status.showMessage("Welcome , No File loaded yet ...")
        #show welcom to user
        self.setStatusBar(self.status)

        
        #Define Widgets 
        #// Banner
        banner=gui.QLabel(self)
        banner.move(5,23)
        banner.setPixmap(pixmap)   
        banner.resize(pixmap.size())
        banner.show()
        banner.setOpenExternalLinks(True)
        #banner.setText("http://google.com")
        self.tabWidget=gui.QTabWidget(self)
        self.tabWidget.resize(388,360)
        self.tabWidget.move(2,60)
        self.tab1=gui.QWidget(self.tabWidget)
        self.tab2=gui.QWidget(self.tabWidget)
        self.tabWidget.addTab(self.tab1,"Single Change         ")
        self.tabWidget.addTab(self.tab2,"Multi Change          ")
        #Group Boxes ///
        box1=gui.QGroupBox("Input File",self.tab1)
        box2=gui.QGroupBox("Output File Options",self.tab1)
        box3=gui.QGroupBox("Output File",self.tab1)
        
        box1.resize(377,80)
        box2.resize(377,130)
        box3.resize(377,80)
        
        box1.move(2,5)
        box2.move(2,95)
        box3.move(2,245)

        box1_1=gui.QGroupBox("Input Files",self.tab2)
        box2_2=gui.QGroupBox("Output Files Options",self.tab2)
        box3_3=gui.QGroupBox("Output Files",self.tab2)
        
        box1_1.resize(377,130)
        box2_2.resize(377,90)
        box3_3.resize(377,80)
        
        box1_1.move(2,5)
        box2_2.move(2,145)
        box3_3.move(2,245)
        
        
        
        #QLine Editors ///
        self.IN=gui.QLineEdit(self.tab1)
        self.OUT=gui.QLineEdit(self.tab1)
        
        self.IN.move(7,35)
        self.OUT.move(7,290)
        
        self.IN.resize(330,30)
        self.OUT.resize(250,30)
        
        self.IN.setToolTip("Choose your input file\nFrom menubar or Button action.")
        self.OUT.setToolTip("Choose your input file\nFrom menubar or Button action.")
        
        self.IN.setReadOnly(True)
        self.OUT.setReadOnly(True)
        
        #Push Buttons :|
        btn1=gui.QPushButton("...",self.tab1)
        btn2=gui.QPushButton("...",self.tab1)
        
        btn1.setToolTip("Open File Browser for input file")
        btn2.setToolTip("Open File Browser for output file")
        btn1.move(342,35)
        btn2.move(342,290)
        
        btn1.resize(30,30)
        btn2.resize(30,30)
        
        btn1.clicked.connect(self.load_in)
        btn2.clicked.connect(self.load_out)
        
        #Combo Boxes :| \\\\\\\
        
        self.combo=gui.QComboBox(self.tab1)
        self.combo.resize(85,30)
        self.combo.move(257,290)
        
        self.combo.addItems(['.jpg','.jpeg','.gif','.bmp' ,'.png'])
        self.combo.setCurrentIndex(0)
        
        self.combo.setToolTip("Suffix of output file")
        
        #QLabel :|
        
        label1=gui.QLabel(self.tab1)
        label1.setText("Output Width  :")
        label1.move(17,130)  
        
        label2=gui.QLabel(self.tab1)
        label2.setText("Output Height  :")
        label2.move(17,160)
        
        label3=gui.QLabel(self.tab1)
        label3.setText("Rotate Deegres :")
        label3.move(17,190)
        
        
        #Spinctrl :|
        
        self.spin_w=gui.QSpinBox(self.tab1)
        
        self.spin_w.move(127,123)
        self.spin_w.resize(80,25)
        self.spin_w.setSuffix(" P")
        
        
        self.spin_h=gui.QSpinBox(self.tab1)
        
        self.spin_h.move(127,153)
        self.spin_h.resize(80,25)
        self.spin_h.setSuffix(" P")
        
        self.spin_d=gui.QSpinBox(self.tab1)
        
        self.spin_d.move(127,183)
        self.spin_d.resize(80,25)
        
        self.spin_w.setMaximum(8000)
        self.spin_h.setMaximum(8000)
        self.spin_d.setMaximum(360)
        self.spin_d.setSuffix(" D")
        self.spin_w.setToolTip("Output file width ( Pixel )")
        self.spin_d.setToolTip("Output file rotation deegres ( Deegres )")
        self.spin_h.setToolTip("Output file height ( Pixel )")
        
        self.spin_d.setMinimum(1)
        
        self.spin_w.setMinimum(1)
        
        self.spin_h.setMinimum(1)
        
        self.spin_d.setValue(90)
        
        self.spin_w.setValue(1024)
        
        self.spin_h.setValue(768)
        
        self.spin_h.setSingleStep(4)
        
        self.spin_w.setSingleStep(4)
        
        self.spin_d.setSingleStep(3)
        
        self.spin_d.setDisabled(True)
        
        self.spin_h.setDisabled(True)
        
        self.spin_w.setDisabled(True)
        
        rad=gui.QRadioButton(self.tab1)
        rad.setText("Resize")
        
        rad.resize(rad.sizeHint())
        rad.move(238,123)
        
        rad2=gui.QRadioButton(self.tab1)
        rad2.setText("Rotate")
        
        rad2.resize(rad2.sizeHint())
        rad2.move(238,153)
        
        rad3=gui.QRadioButton(self.tab1)
        rad3.setText("Both")
        
        rad3.resize(rad3.sizeHint())
        rad3.move(238,183)
        
        rad.setToolTip("Option for resize image")
        rad2.setToolTip("Option for rotate image")
        rad3.setToolTip("Option for resize and rotate image")
        
        
        rad.clicked.connect(self.on_resize)
        
        rad2.clicked.connect(self.on_rotate)
        
        rad3.clicked.connect(self.on_both)
        #Spinctrl :|
        
        self.spin_w1=gui.QSpinBox(self.tab2)
        
        self.spin_w1.move(10,168)
        self.spin_w1.resize(80,25)
        self.spin_w1.setSuffix(" W")
        
        
        self.spin_h2=gui.QSpinBox(self.tab2)
        
        self.spin_h2.move(110,168)
        self.spin_h2.resize(80,25)
        self.spin_h2.setSuffix(" H")
        
        self.spin_d2=gui.QSpinBox(self.tab2)
        
        self.spin_d2.move(210,168)
        self.spin_d2.resize(80,25)
        
        self.spin_w1.setMaximum(8000)
        self.spin_h2.setMaximum(8000)
        self.spin_d2.setMaximum(360)
        self.spin_d2.setSuffix(" R")
        self.spin_w1.setToolTip("Output file width ( Pixel )")
        self.spin_d2.setToolTip("Output file rotation deegres ( Deegres )")
        self.spin_h2.setToolTip("Output file height ( Pixel )")
        
        self.spin_d2.setMinimum(1)
        
        self.spin_w1.setMinimum(1)
        
        self.spin_h2.setMinimum(1)
        
        self.spin_d2.setValue(90)
        
        self.spin_w1.setValue(1024)
        
        self.spin_h2.setValue(768)
        
        self.spin_h2.setSingleStep(4)
        
        self.spin_w1.setSingleStep(4)
        
        self.spin_d2.setSingleStep(3)
        
        self.spin_d2.setDisabled(True)
        
        self.spin_h2.setDisabled(True)
        
        self.spin_w1.setDisabled(True)
        
        rad4=gui.QRadioButton(self.tab2)
        rad4.setText("Resize")
        
        rad4.resize(rad.sizeHint())
        rad4.move(10,195)
        
        rad5=gui.QRadioButton(self.tab2)
        rad5.setText("Rotate")
        
        rad5.resize(rad2.sizeHint())
        rad5.move(110,195)
        
        rad6=gui.QRadioButton(self.tab2)
        rad6.setText("Both")
        
        rad6.resize(rad3.sizeHint())
        rad6.move(210,195)
        
        rad4.setToolTip("Option for resize image")
        rad5.setToolTip("Option for rotate image")
        rad6.setToolTip("Option for resize and rotate image")
        
        
        rad4.clicked.connect(self.on_resize)
        
        rad5.clicked.connect(self.on_rotate)
        
        rad6.clicked.connect(self.on_both)
        self.OUT_Multi=gui.QLineEdit(self.tab2)
        self.OUT_Multi.move(7,270)
        self.OUT_Multi.resize(250,30)
        
        self.OUT_Multi.setToolTip("Choose your input file\nFrom menubar or Button action.")
        self.OUT_Multi.setReadOnly(True)   
        
        btn3=gui.QPushButton("...",self.tab2)
        btn3.setToolTip("Open File Browser for output file")
        btn3.move(342,270)
        btn3.resize(30,30)
        btn3.clicked.connect(self.load_out)
        
        #Combo Boxes :| \\\\\\\
        
        self.combo2=gui.QComboBox(self.tab2)
        self.combo2.resize(85,30)
        self.combo2.move(257,270)
        
        self.combo2.addItems(['.jpg','.jpeg','.gif','.bmp' ,'.png'])
        self.combo2.setCurrentIndex(0)
        
        self.combo2.setToolTip("Suffix of output file")
        
        
        #List Widgets
        self.listWidget=gui.QTableWidget(self.tab2)
        self.listWidget.move(7,10)
        self.listWidget.resize(367,90)
        self.listWidget.setColumnCount(1)
        self.listWidget.setColumnWidth(0,357)
        self.listWidget.setHorizontalHeaderLabels(["File"]);
        #self.listWidget.set
        
        
        add_button=gui.QPushButton("Add",self.tab2)
        add_button.move(8,100)
        add_button.resize(175,25)
        remove_button=gui.QPushButton("Remove",self.tab2)
        remove_button.move(200,100)
        remove_button.resize(175,25)
        add_button.clicked.connect(self.addItem)
        remove_button.clicked.connect(self.removeItem)
        remove_button.setToolTip("Remove a file ")
        add_button.setToolTip("Add files")
    
    def addItem(self,event):
        file_dialog2=gui.QFileDialog.getOpenFileNames(self,"Choose your input Image",os.getcwd(),
        """Images (*.jpg *.png *.gif *.bmp *.jpeg)""")
        file_dialog=[]
        for i in file_dialog2:
            file_dialog.append(str(i))
        if file_dialog:
            with open(main_path+"/core/p_set.irf","w") as g:
                g.write(en(osp.dirname(str(file_dialog[0]))))
                os.chdir(osp.dirname(str(file_dialog[0])))
            file_dialog=list(file_dialog)
            print file_dialog
            for i in file_dialog:
                if i in opt3:
                    continue
                else:
                    opt3.append(i)
                self.listWidget.insertRow(file_dialog.index(i))
                self.listWidget.setRowHeight(file_dialog.index(i),20)
                item=gui.QTableWidgetItem(i)
                item.setFlags(qt.ItemIsEnabled)
                item.setToolTip(item.text())
                self.listWidget.setItem(file_dialog.index(i),0,item)     
            self.status.showMessage(str(self.listWidget.rowCount())+" Files Loaded")
        else:
            self.status.showMessage("No File Loaded")
                
                
    def removeItem(self,event):
        row=self.listWidget.currentRow()
        try:
            opt3.remove(str(self.listWidget.item(0,row).text()))
        except:
            pass
        self.listWidget.removeRow(row)
        
                
    
    def copy_log(self,event):
        Dialog=gui.QFileDialog.getSaveFileName(self,"Save logs file as ...",os.getcwd(),"Text file (*.txt)")
        if Dialog:
            shutil.copy(main_path+"/core/log.txt")
        else:
            pass
    def open_m(self,event):
        
		gui.QMessageBox.information(self,"Sorry","Sorry!\nUnder Construction")
        
    def dellog(self,event):
        
        os.remove(main_path+"/core/log.txt")
    
    def viewlog(self,event):
        if "log.txt" in os.listdir(main_path+"/core/"):
            webbrowser.open(main_path+"/core/log.txt")
        else:
            gui.QMessageBox.warning(self,"Error ","Logs are not available now")
    

    def about_Qt(self,event):
        gui.QMessageBox.aboutQt(self)
        
    def on_resize(self,event):
        
        del opt[:]
        del opt2[:]
        
        opt.append("res")
        opt2.append("res")
        
        self.spin_h.setEnabled(True)
        
        self.spin_w.setEnabled(True)
        
        self.spin_d.setDisabled(True)
        self.spin_h2.setEnabled(True)
        
        self.spin_w1.setEnabled(True)
        
        self.spin_d2.setDisabled(True)
    
    def on_rotate(self,event):
        
        del opt[:]
        del opt2[:]
        
        opt.append("rot")
        opt2.append("rot")
        
        self.spin_d.setEnabled(True)
        
        self.spin_w.setDisabled(True)
        
        self.spin_h.setDisabled(True)
        self.spin_d2.setEnabled(True)
        
        self.spin_w1.setDisabled(True)
        
        self.spin_h2.setDisabled(True)
    
    def on_both(self,event):
        
        del opt[:]
        
        opt.append("both")
        del opt2[:]
        
        opt2.append("both")
        
        self.spin_w.setEnabled(True)
        
        self.spin_h.setEnabled(True)
        
        self.spin_d.setEnabled(True)
        self.spin_w1.setEnabled(True)
        
        self.spin_h2.setEnabled(True)
        
        self.spin_d2.setEnabled(True)       
        
    
        
    def center(self):
        
        qr = self.frameGeometry()
        cp = gui.QDesktopWidget().availableGeometry().center()
        
        qr.moveCenter(cp)
        self.move(qr.topLeft())
    def load_in(self,event):
        if self.tabWidget.currentIndex()==0:
            self.load_in_single()
        else:
            self.addItem(None)
    def load_out(self,event):
        if self.tabWidget.currentIndex()==0:
            self.load_out_single()
        else:
            self.load_out_multi()    
    def start(self,event):
        if self.tabWidget.currentIndex()==0:
            self.start_single()
        else:
            self.start_multi()
    def Over(self,event):
        if self.tabWidget.currentIndex()==0:
            self.Over_single()
        else:
            self.Over_multi()
        
    def start_multi(self):
        if len(opt2)==0:
            
            gui.QMessageBox.warning(self,"Warning","Choose option first\t\t")
            return
        
        else:
            
            if self.listWidget.rowCount()==0:
                
                gui.QMessageBox.warning(self,"Warning","No input file\t\t")
                                
                return
                
            if str(self.OUT_Multi.text())=="":
                
                gui.QMessageBox.warning(self,"Warning","No output file\t\t")
                return
        
            else :
                work=starting_multi()
                
                if opt2[0]=="res":
                    for i in range(self.listWidget.rowCount()):

                        try:
                            work.resize_image(int(self.spin_w.value())
                            ,int(self.spin_h.value()),str(self.listWidget.item(0,i).text()),
                                          str(self.OUT_Multi.text())+str(i+1)+str(self.combo2.currentText()))
                        
                        except Exception,e:
                            gui.QMessageBox.warning(self,"Warning",
                                                    "An error raised on "+str(self.listWidget.item(0,i).text())+"\nTry again!\t\n"+str(e))
                        else:
                            with open(main_path+"/core/log.txt","a") as g:
                                log=get_log("resized",
                                        str(self.listWidget.item(0,i).text()),str(self.OUT.text())+str(self.combo2.currentText()))
                            #print log
                                g.write(log)
                            
                    gui.QMessageBox.information(self,"Completed","Converting "+str(self.listWidget.rowCount())+" Files Completed")
                elif opt2[0]=="rot":
                    
                    for i in range(self.listWidget.rowCount()):
                        try:
                            work.rotate_image(int(self.spin_d2.value()),
                                          str(self.listWidget.item(0,i).text()),
                                          str(self.OUT_Multi.text())+str(i+1)+str(self.combo2.currentText()))
                        
                        except Exception,e:
                            gui.QMessageBox.warning(self,"Warning",
                                                    "An error raised on "+str(self.listWidget.item(0,i).text())+"\nTry again!\t\n"+str(e))
                        else:
                            
                            with open(main_path+"/core/log.txt","a") as g:
                                log=get_log("resized",
                                        str(self.listWidget.item(0,i).text()),str(self.OUT.text())+str(self.combo2.currentText()))
                            #print log
                                g.write(log)
                    gui.QMessageBox.information(self,"Completed","Converting "+str(self.listWidget.rowCount())+" Files Completed")
                else:
                    
                    for i in range(self.listWidget.rowCount()):
                        try:
                            work.do_all(int (self.spin_w1.value()),int(self.spin_h2.value()),int(self.spin_d2.value()),
                                    str(self.listWidget.item(0,i).text()),
                                          str(self.OUT_Multi.text())+str(i+1)+str(self.combo2.currentText()))
                        
                        except Exception,e:
                            gui.QMessageBox.warning(self,"Warning",
                                                    "An error raised on "+str(self.listWidget.item(0,i).text())+"\nTry again!\t\n"+str(e))
                        else:
                            
                            with open(main_path+"/core/log.txt","a") as g:
                                log=get_log("resized",
                                        str(self.listWidget.item(0,i).text()),str(self.OUT.text())+str(self.combo2.currentText()))
                            #print log
                                g.write(log)
                    gui.QMessageBox.information(self,"Completed","Converting "+str(self.listWidget.rowCount())+" Files Completed")

    
    def Over_multi(self):
        dialog=gui.QMessageBox.warning(self
        ,"Alert ","Are you sure \nto overwrite the file?",
        gui.QMessageBox.Yes|gui.QMessageBox.No,gui.QMessageBox.No)
  
        if dialog==gui.QMessageBox.No:
            
            return
        
        else:
            pass
            
        if len(opt2)==0:
            
            gui.QMessageBox.warning(self,"Warning","Choose option first\t\t")
            return
        
        else:
            
            if self.listWidget.rowCount()==0:
                
                gui.QMessageBox.warning(self,"Warning","No input file\t\t")
                                
                return
                
        
            else :
                work=starting_multi()
                
                if opt2[0]=="res":
                    for i in range(self.listWidget.rowCount()):

                        try:
                            work.resize_image(int(self.spin_w1.value())
                            ,int(self.spin_h2.value()),str(self.listWidget.item(0,i).text()),
                                          str(self.listWidget.item(0,i).text()))
                        
                        except Exception,e:
                            gui.QMessageBox.warning(self,"Warning",
                                                    "An error raised on "+str(self.listWidget.item(0,i).text())+"\nTry again!\t\n"+str(e))
                        else:
                            with open(main_path+"/core/log.txt","a") as g:
                                log=get_log("resized",
                                        str(self.listWidget.item(0,i).text()),str(self.listWidget.item(0,i).text()))
                            #print log
                                g.write(log)
                            
                    gui.QMessageBox.information(self,"Completed","Converting "+str(self.listWidget.rowCount())+" Files Completed")
                elif opt2[0]=="rot":
                    
                    for i in range(self.listWidget.rowCount()):
                        try:
                            work.rotate_image(int(self.spin_d2.value()),
                                          str(self.listWidget.item(0,i).text()),
                                          str(self.listWidget.item(0,i).text()))
                        
                        except Exception,e:
                            gui.QMessageBox.warning(self,"Warning",
                                                    "An error raised on "+str(self.listWidget.item(0,i).text())+"\nTry again!\t\n"+str(e))
                        else:
                            
                            with open(main_path+"/core/log.txt","a") as g:
                                log=get_log("resized",
                                        str(self.listWidget.item(0,i).text()),str(self.listWidget.item(0,i).text()))
                            #print log
                                g.write(log)
                    gui.QMessageBox.information(self,"Completed","Converting "+str(self.listWidget.rowCount())+" Files Completed")
                else:
                    
                    for i in range(self.listWidget.rowCount()):
                        try:
                            work.do_all(int (self.spin_w1.value()),int(self.spin_h2.value()),int(self.spin_d2.value()),
                                    str(self.listWidget.item(0,i).text()),
                                          str(self.listWidget.item(0,i).text()))
                        
                        except Exception,e:
                            gui.QMessageBox.warning(self,"Warning",
                                                    "An error raised on "+str(self.listWidget.item(0,i).text())+"\nTry again!\t\n"+str(e))
                        else:
                            
                            with open(main_path+"/core/log.txt","a") as g:
                                log=get_log("resized",
                                        str(self.listWidget.item(0,i).text()),(self.OUT.text()))
                            #print log
                                g.write(log)
                    gui.QMessageBox.information(self,"Completed","Overwriting "+str(self.listWidget.rowCount())+" Files Completed")
    
    def load_out_multi(self):
        file_dialog=gui.QFileDialog.getSaveFileName(self
        ,"Choose output Image (No need to type Suffix)")
        
        self.OUT_Multi.setText(str(file_dialog))
        if str(self.OUT_Multi.text())=="":
            pass
        else:
            with open(main_path+"/core/p_set.irf","w") as g:
                g.write(en(osp.dirname(str(self.OUT_Multi.text()))))       
    def load_in_single(self):
        
        
        file_dialog=gui.QFileDialog.getOpenFileName(self,"Choose your input Image",os.getcwd(),
        """Images (*.jpg *.png *.gif *.bmp *.jpeg)""")
        
        self.IN.setText(str(file_dialog))

        
        if str(self.IN.text())=="":
            self.status.showMessage("No file loaded")
        
        else:
            with open(main_path+"/core/p_set.irf","w") as g:
                g.write(en(osp.dirname(str(self.IN.text()))))
        
            data=get_data(str(self.IN.text()))
        
            size=data.get_size()
        
            path=str(self.IN.text())
        
            size_on=str(getKB(path,2))
        
            self.status.showMessage("Width : "+str(size[0])+" | Height : "+str(size[1])+" | Type : "+data.get_format()+" | Size : "+size_on+" KB")
    
    def load_out_single(self):
        file_dialog=gui.QFileDialog.getSaveFileName(self
        ,"Choose output Image (No need to type Suffix)")
        
        self.OUT.setText(str(file_dialog))
        if str(self.OUT.text())=="":
            pass
        else:
            with open(main_path+"/core/p_set.irf","w") as g:
                g.write(en(osp.dirname(str(self.OUT.text()))))
        
    def start_single(self):
        
        if len(opt)==0:
            
            gui.QMessageBox.warning(self,"Warning","Choose option first\t\t")
            return
        
        else:
            
            if str(self.IN.text())=="":
                
                gui.QMessageBox.warning(self,"Warning","No input file\t\t")
                return
                
            if str(self.OUT.text())=="":
                
                gui.QMessageBox.warning(self,"Warning","No output file\t\t")
                return
        
            else :
                
                work=starting(str(self.IN.text())
                ,str(self.OUT.text())+str(self.combo.currentText()))
                if opt[0]=="res":
                    
                    try:
                        work.resize_image(int(self.spin_w.value())
                        ,int(self.spin_h.value()))
                        
                    except:
                        gui.QMessageBox.warning(self,"Warning",
                        "An error raised\nTry again!\t")
                    
                    else : 
                        gui.QMessageBox.information(self,
                        "Completed",
                        "Completed succesfully\nSaved on : "+str(self.OUT.text())+str(self.combo.currentText())+"\nEnjoy:)")
                        
                        with open(main_path+"/core/log.txt","a") as g:
                            log=get_log("resized",
                                        str(self.IN.text()),(self.OUT.text())+str(self.combo.currentText()))
                            #print log
                            g.write(log)
                            
                            
                elif opt[0]=="rot":
                    
                    try:
                        work.rotate_image(int(self.spin_d.value()))
                        
                    except:
                        gui.QMessageBox.warning(self,
                        "Warning","An error raised\nTry again!\t")
                    
                    else : 
                        gui.QMessageBox.information(self,"Completed",
                        "Completed succesfully\nSaved on : "+str(self.OUT.text())+str(self.combo.currentText())+"\nEnjoy:)")
                        with open(main_path+"/core/log.txt","a") as g:
                            log=get_log("rotated",str(self.IN.text()),(self.OUT.text())+str(self.combo.currentText()))
                            #print log
                            g.write(log)

                else:
                    
                    try:
                        work.do_all(int(self.spin_w.value()),
                                    int(self.spin_h.value()),int(self.spin_d.value()))
                    
                    except Exception,e :
                        gui.QMessageBox.warning(self,"Warning","An error raised\n"+e+"\nTry again!\t")
                    
                    else:
                        gui.QMessageBox.information(self,"Completed",
                        "Completed succesfully\nOverwrited on : "+str(self.IN.text())+"\nEnjoy :)\t")
                        with open(main_path+"/core/log.txt","a") as g:
                            log=get_log("resized and rotated",
                                        str(self.IN.text()),(self.OUT.text())+str(self.combo.currentText()))
                            #print log
                            g.write(log)

            

    def about(self,event):
        msg=gui.QMessageBox(self)
        
        msg.about(self,"About Image Resizer",about_msg)

        

    def Over_single(self):
        
        if len(opt)==0:
            
            gui.QMessageBox.warning(self,"Warning","Choose option first \t")
            
            return
            
        dialog=gui.QMessageBox.warning(self
        ,"Alert ","Are you sure \nto overwrite the file?",
        gui.QMessageBox.Yes|gui.QMessageBox.No,gui.QMessageBox.No)
  
        if dialog==gui.QMessageBox.No:
            
            pass
        
        else:
            if str(self.IN.text())=="":
                
                gui.QMessageBox.warning(self,"Warning","No input file\t\t")
                
            else :
                
                work=starting(str(self.IN.text()),str(self.IN.text()))
                
                if opt[0]=="res":
                    
                    try:
                        work.resize_image(int(self.spin_w.value()),
                                          int(self.spin_h.value()))
                    
                    except:
                        gui.QMessageBox.warning(self,"Warning",
                        "An error raised\nTry again!\t")
                    
                    else:
                        
                        gui.QMessageBox.information(self,
                        "Completed","Completed succesfully\nOverwrited on : "+str(self.IN.text())+"\nEnjoy :)\t")
                        with open(main_path+"/core/log.txt","a") as g:
                            log=get_log("resized"
                            ,str(self.IN.text()),
(self.IN.text())+str(self.combo.currentText()))
                            #print log
                            g.write(log)

                elif opt[0]=="rot":
                    
                    try:
                        work.rotate_image(int(self.spin_d.value()))
                    
                    except:
                        gui.QMessageBox.warning(self,"Warning",
                        "An error raised\nTry again!\t")
                        
                    else:
                        gui.QMessageBox.information(self,
                        "Completed","Completed succesfully\nOverwrited on : "+str(self.IN.text())+"\nEnjoy :)\t")
                        with open(main_path+"/core/log.txt","a") as g:
                            log=get_log("rotated",str(self.IN.text()),
                                        (self.IN.text())+str(self.combo.currentText()))
                            #print log
                            g.write(log)

                else:
                    
                    try:
                        work.do_all(int(self.spin_w.value()),
                                    int(self.spin_h.value()),int(self.spin_d.value()))
                    
                    except :
                        gui.QMessageBox.warning(self,
                        "Warning","An error raised\nTry again!\t")
                    
                    else:
                        
                        gui.QMessageBox.information(self,"Completed"
                        ,"Completed succesfully\nOverwrited on : "+str(self.IN.text())+"\nEnjoy :)\t")
                        with open(main_path+"/core/log.txt","a") as g:
                            
                            log=get_log("resized and rotated"
                            ,str(self.IN.text()),(self.IN.text())+str(self.combo.currentText()))
                            #print log
                            g.write(log)

main=Gui()
main.show()
sys.exit(app.exec_())
#Remember me 
#Coded by Amir Bakhtiary
###############################################################################
